diff -Naur -x '*.dia' -x '*.pcap' -x '*.png' ns-3.37/src/core/test/val-array-test-suite.cc ns-3.38/src/core/test/val-array-test-suite.cc
--- ns-3.37/src/core/test/val-array-test-suite.cc	1969-12-31 16:00:00.000000000 -0800
+++ ns-3.38/src/core/test/val-array-test-suite.cc	2023-03-16 20:54:23.600868500 -0700
@@ -0,0 +1,297 @@
+/*
+ * Copyright (c) 2022 Centre Tecnologic de Telecomunicacions de Catalunya (CTTC)
+ *
+ * This program is free software; you can redistribute it and/or modify
+ * it under the terms of the GNU General Public License version 2 as
+ * published by the Free Software Foundation;
+ *
+ * This program is distributed in the hope that it will be useful,
+ * but WITHOUT ANY WARRANTY; without even the implied warranty of
+ * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
+ * GNU General Public License for more details.
+ *
+ * You should have received a copy of the GNU General Public License
+ * along with this program; if not, write to the Free Software
+ * Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
+ *
+ * Author: Biljana Bojovic <bbojovic@cttc.es>
+ */
+
+#include "ns3/log.h"
+#include "ns3/test.h"
+#include "ns3/val-array.h"
+
+/**
+ * \ingroup core-tests
+ */
+
+namespace ns3
+{
+namespace tests
+{
+
+NS_LOG_COMPONENT_DEFINE("ValArrayTest");
+
+/**
+ * @brief ValArray test case for testing ValArray class
+ *
+ * @tparam T the template parameter that can be a complex number, double or int
+ */
+template <class T>
+class ValArrayTestCase : public TestCase
+{
+  public:
+    /** Default constructor*/
+    ValArrayTestCase<T>() = default;
+    /**
+     * Constructor
+     *
+     * \param [in] name reference name
+     */
+    ValArrayTestCase<T>(const std::string name);
+
+    /** Destructor. */
+    ~ValArrayTestCase<T>() override;
+    /**
+     * \brief Copy constructor.
+     * Instruct the compiler to generate the implicitly declared copy constructor
+     */
+    ValArrayTestCase<T>(const ValArrayTestCase<T>&) = default;
+    /**
+     * \brief Copy assignment operator.
+     * Instruct the compiler to generate the implicitly declared copy assignment operator.
+     * \return A reference to this ValArrayTestCase
+     */
+    ValArrayTestCase<T>& operator=(const ValArrayTestCase<T>&) = default;
+    /**
+     * \brief Move constructor.
+     * Instruct the compiler to generate the implicitly declared move constructor
+     */
+    ValArrayTestCase<T>(ValArrayTestCase<T>&&) = default;
+    /**
+     * \brief Move assignment operator.
+     * Instruct the compiler to generate the implicitly declared copy constructor
+     * \return A reference to this ValArrayTestCase
+     */
+    ValArrayTestCase<T>& operator=(ValArrayTestCase<T>&&) = default;
+
+  private:
+    void DoRun() override;
+};
+
+template <class T>
+ValArrayTestCase<T>::ValArrayTestCase(const std::string name)
+    : TestCase(name)
+{
+}
+
+template <class T>
+ValArrayTestCase<T>::~ValArrayTestCase<T>()
+{
+}
+
+template <class T>
+void
+ValArrayTestCase<T>::DoRun()
+{
+    ValArray<T> v1 = ValArray<T>(2, 3);
+    for (uint16_t i = 0; i < v1.GetNumRows(); ++i)
+    {
+        for (uint16_t j = 0; j < v1.GetNumCols(); ++j)
+        {
+            v1(i, j) = 1;
+        }
+    }
+
+    ValArray<T> v2 = ValArray<T>(v1);
+    NS_TEST_ASSERT_MSG_EQ(v1.GetNumRows(), v2.GetNumRows(), "The number of rows are not equal.");
+    NS_TEST_ASSERT_MSG_EQ(v1.GetNumCols(), v2.GetNumCols(), "The number of cols are not equal.");
+
+    // test copy constructor
+    for (uint16_t i = 0; i < v1.GetNumRows(); ++i)
+    {
+        for (uint16_t j = 0; j < v1.GetNumCols(); ++j)
+        {
+            NS_TEST_ASSERT_MSG_EQ(v1(i, j), v2(i, j), "The elements are not equal.");
+        }
+    }
+
+    // test assign constructor
+    ValArray<T> v3 = v1;
+    NS_TEST_ASSERT_MSG_EQ(v1.GetNumRows(), v3.GetNumRows(), "The number of rows are not equal.");
+    NS_TEST_ASSERT_MSG_EQ(v1.GetNumCols(), v3.GetNumCols(), "The number of cols are not equal.");
+    for (uint16_t i = 0; i < v1.GetNumRows(); ++i)
+    {
+        for (uint16_t j = 0; j < v1.GetNumCols(); ++j)
+        {
+            NS_TEST_ASSERT_MSG_EQ(v1(i, j), v2(i, j), "The elements are not equal.");
+        }
+    }
+
+    // test move assignment operator
+    ValArray<T> v4;
+    NS_LOG_INFO("v1 size before move: " << v1.GetSize());
+    NS_LOG_INFO("v4 size before move: " << v4.GetSize());
+    size_t v1size = v1.GetSize();
+    v4 = std::move(v1);
+    NS_LOG_INFO("v4 size after move: " << v4.GetSize());
+    NS_TEST_ASSERT_MSG_EQ(v1size, v4.GetSize(), "The number of elements are not equal.");
+    for (uint16_t i = 0; i < v4.GetNumRows(); ++i)
+    {
+        for (uint16_t j = 0; j < v4.GetNumCols(); ++j)
+        {
+            // Use v3 for comparison since it hasn't moved
+            NS_TEST_ASSERT_MSG_EQ(v3(i, j), v4(i, j), "The elements are not equal.");
+        }
+    }
+
+    // test move constructor
+    NS_LOG_INFO("v3 size before move: " << v3.GetSize());
+    size_t v3size = v3.GetSize();
+    ValArray<T> v5(std::move(v3));
+    NS_TEST_ASSERT_MSG_EQ(v3size, v5.GetSize(), "The number of elements are not equal.");
+    for (uint16_t i = 0; i < v5.GetNumRows(); ++i)
+    {
+        for (uint16_t j = 0; j < v5.GetNumCols(); ++j)
+        {
+            // Use v4 for comparison since it hasn't moved
+            NS_TEST_ASSERT_MSG_EQ(v4(i, j), v5(i, j), "The elements are not equal.");
+        }
+    }
+
+    // test constructor with initialization valArray
+    std::valarray<int> initArray1{0, 1, 2, 3, 4, 5, 6, 7};
+    std::valarray<T> valArray1(initArray1.size()); // length is 8 elements
+    for (size_t i = 0; i < initArray1.size(); i++)
+    {
+        valArray1[i] = static_cast<T>(initArray1[i]);
+    }
+    ValArray<T> v6 = ValArray<T>(2, 4, valArray1);
+
+    // test constructor that moves valArray
+    NS_LOG_INFO("valarray1 size before move: " << valArray1.size());
+    ValArray<T> v11 = ValArray<T>(2, 4, std::move(valArray1));
+    NS_LOG_INFO("valarray1 size after move: " << valArray1.size());
+    NS_LOG_INFO("v11 size after move: " << v11.GetSize());
+
+    // test whether column-major order was respected during the initialization and
+    // also in the access operator if we iterate over rows first we should find 0, 2, 4, 6, ...
+    std::valarray<int> initArray2{0, 2, 4, 6, 1, 3, 5, 7};
+    auto testIndex = 0;
+    for (uint16_t i = 0; i < v6.GetNumRows(); ++i)
+    {
+        for (uint16_t j = 0; j < v6.GetNumCols(); ++j)
+        {
+            NS_TEST_ASSERT_MSG_EQ(v6(i, j),
+                                  static_cast<T>(initArray2[testIndex]),
+                                  "The values are not equal.");
+            testIndex++;
+        }
+    }
+
+    // test constructor with initialization valArray for 3D array
+    std::valarray<int> initArray3{0, 1, 2, 3, 4, 5, 6, 7, 0, 1, 2, 3, 4, 5, 6, 7};
+    std::valarray<T> valArray2(initArray3.size()); // length is 8 elements
+    for (size_t i = 0; i < initArray3.size(); i++)
+    {
+        valArray2[i] = static_cast<T>(initArray3[i]);
+    }
+
+    ValArray<T> v7 = ValArray<T>(2, 4, 2, valArray2);
+    // test whether column-major order was respected during the initialization and
+    // also in the access operator
+    // if we iterate over rows first we should find 0, 2, 4, 6, ...
+    std::valarray<int> initArray4{0, 2, 4, 6, 1, 3, 5, 7, 0, 2, 4, 6, 1, 3, 5, 7};
+    testIndex = 0;
+    for (uint16_t p = 0; p < v7.GetNumPages(); ++p)
+    {
+        for (uint16_t i = 0; i < v7.GetNumRows(); ++i)
+        {
+            for (uint16_t j = 0; j < v7.GetNumCols(); ++j)
+            {
+                NS_TEST_ASSERT_MSG_EQ(v7(i, j, p),
+                                      static_cast<T>(initArray4[testIndex]),
+                                      "The values are not equal.");
+                testIndex++;
+            }
+        }
+    }
+
+    // multiplication with a scalar value with 3D array
+    ValArray<T> v8 = v7 * (static_cast<T>(5.0));
+    for (uint16_t p = 0; p < v8.GetNumPages(); ++p)
+    {
+        for (uint16_t i = 0; i < v8.GetNumRows(); ++i)
+        {
+            for (uint16_t j = 0; j < v8.GetNumCols(); ++j)
+            {
+                NS_TEST_ASSERT_MSG_EQ(v7(i, j, p) * (static_cast<T>(5.0)),
+                                      v8(i, j, p),
+                                      "The values are not equal");
+            }
+        }
+    }
+
+    NS_LOG_INFO("v8 = v7 * 5:" << v8);
+    // test +, - (binary, unary) operators
+    NS_LOG_INFO("v8 + v8" << v8 + v8);
+    NS_LOG_INFO("v8 - v8" << v8 - v8);
+    NS_LOG_INFO("-v8" << -v8);
+
+    // test +=  and -= assignment operators
+    ValArray<T> v9(v8.GetNumRows(), v8.GetNumCols(), v8.GetNumPages());
+    v9 += v8;
+    NS_LOG_INFO("v9 += v8" << v9);
+    ValArray<T> v10(v8.GetNumRows(), v8.GetNumCols(), v8.GetNumPages());
+    v10 -= v8;
+    NS_LOG_INFO("v10 -= v8" << v10);
+
+    // test == and != operators
+    NS_TEST_ASSERT_MSG_EQ(bool(v9 == v8), true, "Matrices v8 and v9 should be equal");
+    NS_TEST_ASSERT_MSG_EQ(bool(v10 == v8), false, "Matrices v8 and v10 should not be equal");
+    NS_TEST_ASSERT_MSG_EQ(bool(v10 != v8), true, "Matrices v8 and v10 should not be equal");
+    // test whether arrays are equal when they have different lengths
+    NS_TEST_ASSERT_MSG_NE(ValArray<int>(std::valarray({1, 2, 3})),
+                          ValArray<int>(std::valarray({1, 2, 3, 4})),
+                          "Arrays should not be equal, they have different dimensions.");
+
+    // test the function IsAlmostEqual
+    v9(0, 0, 0) = v9(0, 0, 0) + static_cast<T>(1);
+    NS_TEST_ASSERT_MSG_EQ(v9.IsAlmostEqual(v8, 2) && (v9 != v8),
+                          true,
+                          "Matrices should be almost equal, but not equal.");
+
+    // test the initialization with std::vector
+    ValArray<T> v12 = ValArray(std::vector<T>({1, 2, 3}));
+    NS_LOG_INFO("v12:" << v12);
+}
+
+/**
+ * \ingroup valArray-tests
+ * ValArray test suite
+ *
+ * \brief The test checks the correct behaviour of ValArray class
+ */
+class ValArrayTestSuite : public TestSuite
+{
+  public:
+    /** Constructor. */
+    ValArrayTestSuite();
+};
+
+ValArrayTestSuite::ValArrayTestSuite()
+    : TestSuite("val-array-test")
+{
+    AddTestCase(new ValArrayTestCase<double>("Test ValArray<double>"));
+    AddTestCase(new ValArrayTestCase<std::complex<double>>("Test ValArray<std::complex<double>>"));
+    AddTestCase(new ValArrayTestCase<int>("Test ValArray<int>"));
+}
+
+/**
+ * \ingroup valArray-tests
+ * ValArrayTestSuite instance variable.
+ */
+static ValArrayTestSuite g_valArrayTestSuite;
+
+} // namespace tests
+} // namespace ns3
diff -Naur -x '*.dia' -x '*.pcap' -x '*.png' ns-3.37/src/csma/examples/csma-broadcast.cc ns-3.38/src/csma/examples/csma-broadcast.cc
--- ns-3.37/src/csma/examples/csma-broadcast.cc	2022-11-01 17:37:24.479395200 -0700
+++ ns-3.38/src/csma/examples/csma-broadcast.cc	2023-03-16 20:54:23.600868500 -0700
@@ -121,4 +121,6 @@
     Simulator::Run();
     Simulator::Destroy();
     NS_LOG_INFO("Done.");
+
+    return 0;
 }
diff -Naur -x '*.dia' -x '*.pcap' -x '*.png' ns-3.37/src/csma/examples/csma-multicast.cc ns-3.38/src/csma/examples/csma-multicast.cc
--- ns-3.37/src/csma/examples/csma-multicast.cc	2022-11-01 17:37:24.479395200 -0700
+++ ns-3.38/src/csma/examples/csma-multicast.cc	2023-03-16 20:54:23.600868500 -0700
@@ -178,4 +178,6 @@
     Simulator::Run();
     Simulator::Destroy();
     NS_LOG_INFO("Done.");
+
+    return 0;
 }
diff -Naur -x '*.dia' -x '*.pcap' -x '*.png' ns-3.37/src/csma/examples/csma-one-subnet.cc ns-3.38/src/csma/examples/csma-one-subnet.cc
--- ns-3.37/src/csma/examples/csma-one-subnet.cc	2022-11-01 17:37:24.479395200 -0700
+++ ns-3.38/src/csma/examples/csma-one-subnet.cc	2023-03-16 20:54:23.600868500 -0700
@@ -138,4 +138,6 @@
     Simulator::Run();
     Simulator::Destroy();
     NS_LOG_INFO("Done.");
+
+    return 0;
 }
diff -Naur -x '*.dia' -x '*.pcap' -x '*.png' ns-3.37/src/csma/examples/csma-packet-socket.cc ns-3.38/src/csma/examples/csma-packet-socket.cc
--- ns-3.37/src/csma/examples/csma-packet-socket.cc	2022-11-01 17:37:24.479395200 -0700
+++ ns-3.38/src/csma/examples/csma-packet-socket.cc	2023-03-16 20:54:23.600868500 -0700
@@ -40,7 +40,7 @@
 
 NS_LOG_COMPONENT_DEFINE("CsmaPacketSocketExample");
 
-/// Ouput stream.
+/// Output stream.
 std::ofstream g_os;
 
 /**
diff -Naur -x '*.dia' -x '*.pcap' -x '*.png' ns-3.37/src/csma/examples/csma-ping.cc ns-3.38/src/csma/examples/csma-ping.cc
--- ns-3.37/src/csma/examples/csma-ping.cc	2022-11-01 17:37:24.479395200 -0700
+++ ns-3.38/src/csma/examples/csma-ping.cc	2023-03-16 20:54:23.600868500 -0700
@@ -47,25 +47,31 @@
 static void
 SinkRx(Ptr<const Packet> p, const Address& ad)
 {
-    // std::cout << *p << std::endl;
+    std::cout << *p << std::endl;
 }
 
 /**
  * Ping RTT trace sink
  *
  * \param context The context.
+ * \param seqNo The Sequence Number.
  * \param rtt The RTT.
  */
 static void
-PingRtt(std::string context, Time rtt)
+PingRtt(std::string context, uint16_t seqNo, Time rtt)
 {
-    // std::cout << context << " " << rtt << std::endl;
+    std::cout << context << " " << seqNo << " " << rtt << std::endl;
 }
 
 int
 main(int argc, char* argv[])
 {
+    bool verbose{false};
+
     CommandLine cmd(__FILE__);
+    cmd.AddValue("verbose",
+                 "print received background traffic packets and ping RTT values",
+                 verbose);
     cmd.Parse(argc, argv);
 
     // Here, we will explicitly create four nodes.
@@ -110,7 +116,7 @@
     apps.Stop(Seconds(11.0));
 
     NS_LOG_INFO("Create pinger");
-    V4PingHelper ping = V4PingHelper(addresses.GetAddress(2));
+    PingHelper ping(addresses.GetAddress(2));
     NodeContainer pingers;
     pingers.Add(c.Get(0));
     pingers.Add(c.Get(1));
@@ -123,11 +129,14 @@
     // first, pcap tracing in non-promiscuous mode
     csma.EnablePcapAll("csma-ping", false);
 
-    // then, print what the packet sink receives.
-    Config::ConnectWithoutContext("/NodeList/3/ApplicationList/0/$ns3::PacketSink/Rx",
-                                  MakeCallback(&SinkRx));
-    // finally, print the ping rtts.
-    Config::Connect("/NodeList/*/ApplicationList/*/$ns3::V4Ping/Rtt", MakeCallback(&PingRtt));
+    if (verbose)
+    {
+        // then, print what the packet sink receives.
+        Config::ConnectWithoutContext("/NodeList/3/ApplicationList/0/$ns3::PacketSink/Rx",
+                                      MakeCallback(&SinkRx));
+        // finally, print the ping rtts.
+        Config::Connect("/NodeList/*/ApplicationList/*/$ns3::Ping/Rtt", MakeCallback(&PingRtt));
+    }
 
     Packet::EnablePrinting();
 
@@ -135,4 +144,6 @@
     Simulator::Run();
     Simulator::Destroy();
     NS_LOG_INFO("Done.");
+
+    return 0;
 }
diff -Naur -x '*.dia' -x '*.pcap' -x '*.png' ns-3.37/src/csma/examples/csma-raw-ip-socket.cc ns-3.38/src/csma/examples/csma-raw-ip-socket.cc
--- ns-3.37/src/csma/examples/csma-raw-ip-socket.cc	2022-11-01 17:37:24.479395200 -0700
+++ ns-3.38/src/csma/examples/csma-raw-ip-socket.cc	2023-03-16 20:54:23.600868500 -0700
@@ -121,4 +121,6 @@
     Simulator::Run();
     Simulator::Destroy();
     NS_LOG_INFO("Done.");
+
+    return 0;
 }
diff -Naur -x '*.dia' -x '*.pcap' -x '*.png' ns-3.37/src/csma/model/backoff.cc ns-3.38/src/csma/model/backoff.cc
--- ns-3.37/src/csma/model/backoff.cc	2022-11-01 17:37:24.479395200 -0700
+++ ns-3.38/src/csma/model/backoff.cc	2023-03-16 20:54:23.600868500 -0700
@@ -88,7 +88,7 @@
 }
 
 bool
-Backoff::MaxRetriesReached()
+Backoff::MaxRetriesReached() const
 {
     return (m_numBackoffRetries >= m_maxRetries);
 }
diff -Naur -x '*.dia' -x '*.pcap' -x '*.png' ns-3.37/src/csma/model/backoff.h ns-3.38/src/csma/model/backoff.h
--- ns-3.37/src/csma/model/backoff.h	2022-11-01 17:37:24.479395200 -0700
+++ ns-3.38/src/csma/model/backoff.h	2023-03-16 20:54:23.600868500 -0700
@@ -97,7 +97,7 @@
     /**
      * \return True if the maximum number of retries has been reached
      */
-    bool MaxRetriesReached();
+    bool MaxRetriesReached() const;
 
     /**
      * Increments the number of retries by 1.
@@ -116,7 +116,7 @@
 
   private:
     /**
-     * Number of times that the transmitter has tried to unsuccessfully transmit the current packet.
+     * Number of times that the transmitter has tried to unsuccessfuly transmit the current packet.
      */
     uint32_t m_numBackoffRetries;
 
diff -Naur -x '*.dia' -x '*.pcap' -x '*.png' ns-3.37/src/csma/model/csma-channel.cc ns-3.38/src/csma/model/csma-channel.cc
--- ns-3.37/src/csma/model/csma-channel.cc	2022-11-01 17:37:24.479395200 -0700
+++ ns-3.38/src/csma/model/csma-channel.cc	2023-03-16 20:54:23.600868500 -0700
@@ -362,7 +362,7 @@
 }
 
 bool
-CsmaDeviceRec::IsActive()
+CsmaDeviceRec::IsActive() const
 {
     return active;
 }
diff -Naur -x '*.dia' -x '*.pcap' -x '*.png' ns-3.37/src/csma/model/csma-channel.h ns-3.38/src/csma/model/csma-channel.h
--- ns-3.37/src/csma/model/csma-channel.h	2022-11-01 17:37:24.479395200 -0700
+++ ns-3.38/src/csma/model/csma-channel.h	2023-03-16 20:54:23.600868500 -0700
@@ -65,7 +65,7 @@
      * \return If the net device pointed to by the devicePtr is active
      * and ready to RX/TX.
      */
-    bool IsActive();
+    bool IsActive() const;
 };
 
 /**
diff -Naur -x '*.dia' -x '*.pcap' -x '*.png' ns-3.37/src/csma/model/csma-net-device.cc ns-3.38/src/csma/model/csma-net-device.cc
--- ns-3.37/src/csma/model/csma-net-device.cc	2022-11-01 17:37:24.479395200 -0700
+++ ns-3.38/src/csma/model/csma-net-device.cc	2023-03-16 20:54:23.600868500 -0700
@@ -223,7 +223,7 @@
 }
 
 void
-CsmaNetDevice::SetEncapsulationMode(enum EncapsulationMode mode)
+CsmaNetDevice::SetEncapsulationMode(EncapsulationMode mode)
 {
     NS_LOG_FUNCTION(mode);
 
@@ -274,14 +274,14 @@
 }
 
 bool
-CsmaNetDevice::IsSendEnabled()
+CsmaNetDevice::IsSendEnabled() const
 {
     NS_LOG_FUNCTION_NOARGS();
     return m_sendEnable;
 }
 
 bool
-CsmaNetDevice::IsReceiveEnabled()
+CsmaNetDevice::IsReceiveEnabled() const
 {
     NS_LOG_FUNCTION_NOARGS();
     return m_receiveEnable;
@@ -368,7 +368,7 @@
 
         //
         // All Ethernet frames must carry a minimum payload of 46 bytes.  The
-        // LLC SNAP header counts as part of this payload.  We need to padd out
+        // LLC SNAP header counts as part of this payload.  We need to pad out
         // if we don't have enough bytes.  These must be real bytes since they
         // will be written to pcap files and compared in regression trace files.
         //
diff -Naur -x '*.dia' -x '*.pcap' -x '*.png' ns-3.37/src/csma/model/csma-net-device.h ns-3.38/src/csma/model/csma-net-device.h
--- ns-3.37/src/csma/model/csma-net-device.h	2022-11-01 17:37:24.479395200 -0700
+++ ns-3.38/src/csma/model/csma-net-device.h	2023-03-16 20:54:23.600868500 -0700
@@ -178,7 +178,7 @@
      *
      * \returns True if the send side is enabled, otherwise false.
      */
-    bool IsSendEnabled();
+    bool IsSendEnabled() const;
 
     /**
      * Enable or disable the send side of the network device.
@@ -192,7 +192,7 @@
      *
      * \returns True if the receiver side is enabled, otherwise false.
      */
-    bool IsReceiveEnabled();
+    bool IsReceiveEnabled() const;
 
     /**
      * Enable or disable the receive side of the network device.
diff -Naur -x '*.dia' -x '*.pcap' -x '*.png' ns-3.37/src/csma-layout/examples/csma-star.cc ns-3.38/src/csma-layout/examples/csma-star.cc
--- ns-3.37/src/csma-layout/examples/csma-star.cc	2022-11-01 17:37:24.479395200 -0700
+++ ns-3.38/src/csma-layout/examples/csma-star.cc	2023-03-16 20:54:23.600868500 -0700
@@ -116,7 +116,7 @@
     // assign addresses to them as well.  We put all of the fill devices into
     // a single device container, so the first nFill devices are associated
     // with the channel connected to spokeDevices.Get (0), the second nFill
-    // devices afe associated with the channel connected to spokeDevices.Get (1)
+    // devices are associated with the channel connected to spokeDevices.Get (1)
     // etc.
     //
     Ipv4AddressHelper address;
diff -Naur -x '*.dia' -x '*.pcap' -x '*.png' ns-3.37/src/dsdv/examples/dsdv-manet.cc ns-3.38/src/dsdv/examples/dsdv-manet.cc
--- ns-3.37/src/dsdv/examples/dsdv-manet.cc	2022-11-01 17:37:24.479395200 -0700
+++ ns-3.38/src/dsdv/examples/dsdv-manet.cc	2023-03-16 20:54:23.600868500 -0700
@@ -377,7 +377,7 @@
     {
         Ptr<OutputStreamWrapper> routingStream =
             Create<OutputStreamWrapper>((tr_name + ".routes"), std::ios::out);
-        dsdv.PrintRoutingTableAllAt(Seconds(m_periodicUpdateInterval), routingStream);
+        Ipv4RoutingHelper::PrintRoutingTableAllAt(Seconds(m_periodicUpdateInterval), routingStream);
     }
 }
 
diff -Naur -x '*.dia' -x '*.pcap' -x '*.png' ns-3.37/src/dsdv/model/dsdv-packet-queue.cc ns-3.38/src/dsdv/model/dsdv-packet-queue.cc
--- ns-3.37/src/dsdv/model/dsdv-packet-queue.cc	2022-11-01 17:37:24.479395200 -0700
+++ ns-3.38/src/dsdv/model/dsdv-packet-queue.cc	2023-03-16 20:54:23.600868500 -0700
@@ -53,7 +53,7 @@
 bool
 PacketQueue::Enqueue(QueueEntry& entry)
 {
-    NS_LOG_FUNCTION("Enqueing packet destined for" << entry.GetIpv4Header().GetDestination());
+    NS_LOG_FUNCTION("Enqueuing packet destined for" << entry.GetIpv4Header().GetDestination());
     Purge();
     uint32_t numPacketswithdst;
     for (std::vector<QueueEntry>::const_iterator i = m_queue.begin(); i != m_queue.end(); ++i)
@@ -74,7 +74,7 @@
     }
     else
     {
-        // NS_LOG_DEBUG("Packet size while enqueing "<<entry.GetPacket()->GetSize());
+        // NS_LOG_DEBUG("Packet size while enqueuing "<<entry.GetPacket()->GetSize());
         entry.SetExpireTime(m_queueTimeout);
         m_queue.push_back(entry);
         return true;
diff -Naur -x '*.dia' -x '*.pcap' -x '*.png' ns-3.37/src/dsdv/model/dsdv-routing-protocol.cc ns-3.38/src/dsdv/model/dsdv-routing-protocol.cc
--- ns-3.37/src/dsdv/model/dsdv-routing-protocol.cc	2022-11-01 17:37:24.479395200 -0700
+++ ns-3.38/src/dsdv/model/dsdv-routing-protocol.cc	2023-03-16 20:54:23.600868500 -0700
@@ -826,7 +826,7 @@
     }
     std::map<Ipv4Address, RoutingTableEntry> allRoutes;
     m_advRoutingTable.GetListOfAllRoutes(allRoutes);
-    if (EnableRouteAggregation && allRoutes.size() > 0)
+    if (EnableRouteAggregation && !allRoutes.empty())
     {
         Simulator::Schedule(m_routeAggregationTime, &RoutingProtocol::SendTriggeredUpdate, this);
     }
@@ -1280,7 +1280,7 @@
         "Merging advertised table changes with main table before sending out periodic update");
     std::map<Ipv4Address, RoutingTableEntry> allRoutes;
     m_advRoutingTable.GetListOfAllRoutes(allRoutes);
-    if (allRoutes.size() > 0)
+    if (!allRoutes.empty())
     {
         for (std::map<Ipv4Address, RoutingTableEntry>::const_iterator i = allRoutes.begin();
              i != allRoutes.end();
diff -Naur -x '*.dia' -x '*.pcap' -x '*.png' ns-3.37/src/dsdv/model/dsdv-routing-protocol.h ns-3.38/src/dsdv/model/dsdv-routing-protocol.h
--- ns-3.37/src/dsdv/model/dsdv-routing-protocol.h	2022-11-01 17:37:24.479395200 -0700
+++ ns-3.38/src/dsdv/model/dsdv-routing-protocol.h	2023-03-16 20:54:23.600868500 -0700
@@ -179,7 +179,7 @@
     bool EnableBuffering;
     /// Flag that is used to enable or disable Weighted Settling Time
     bool EnableWST;
-    /// This is the wighted factor to determine the weighted settling time
+    /// This is the weighted factor to determine the weighted settling time
     double m_weightedFactor;
     /// This is a flag to enable route aggregation. Route aggregation will aggregate all routes for
     /// 'RouteAggregationTime' from the time an update is received by a node and sends them as a
diff -Naur -x '*.dia' -x '*.pcap' -x '*.png' ns-3.37/src/dsdv/model/dsdv-rtable.h ns-3.38/src/dsdv/model/dsdv-rtable.h
--- ns-3.37/src/dsdv/model/dsdv-rtable.h	2022-11-01 17:37:24.479395200 -0700
+++ ns-3.38/src/dsdv/model/dsdv-rtable.h	2023-03-16 20:54:23.600868500 -0700
@@ -432,7 +432,7 @@
      */
     bool ForceDeleteIpv4Event(Ipv4Address address);
     /**
-     * Get the EcentId associated with that address.
+     * Get the EventId associated with that address.
      * \param address destination address for which this event is running.
      * \return EventId on finding out an event is associated else return NULL.
      */
diff -Naur -x '*.dia' -x '*.pcap' -x '*.png' ns-3.37/src/dsdv/test/dsdv-testcase.cc ns-3.38/src/dsdv/test/dsdv-testcase.cc
--- ns-3.37/src/dsdv/test/dsdv-testcase.cc	2022-11-01 17:37:24.479395200 -0700
+++ ns-3.38/src/dsdv/test/dsdv-testcase.cc	2023-03-16 20:54:23.600868500 -0700
@@ -46,13 +46,13 @@
 using namespace ns3;
 
 /**
- * \ingroup dsdv-test
+ * \ingroup dsdv
+ * \ingroup tests
  * \defgroup dsdv-test DSDV module tests
  */
 
 /**
  * \ingroup dsdv-test
- * \ingroup tests
  *
  * \brief DSDV test case to verify the DSDV header
  *
@@ -111,7 +111,6 @@
 
 /**
  * \ingroup dsdv-test
- * \ingroup tests
  *
  * \brief DSDV routing table tests (adding and looking up routes)
  */
@@ -213,7 +212,6 @@
 
 /**
  * \ingroup dsdv-test
- * \ingroup tests
  *
  * \brief DSDV test suite
  */
diff -Naur -x '*.dia' -x '*.pcap' -x '*.png' ns-3.37/src/dsr/examples/dsr.cc ns-3.38/src/dsr/examples/dsr.cc
--- ns-3.37/src/dsr/examples/dsr.cc	2022-11-01 17:37:24.479395200 -0700
+++ ns-3.38/src/dsr/examples/dsr.cc	2023-03-16 20:54:23.600868500 -0700
@@ -214,4 +214,6 @@
     Simulator::Stop(Seconds(TotalTime));
     Simulator::Run();
     Simulator::Destroy();
+
+    return 0;
 }
diff -Naur -x '*.dia' -x '*.pcap' -x '*.png' ns-3.37/src/dsr/model/dsr-fs-header.cc ns-3.38/src/dsr/model/dsr-fs-header.cc
--- ns-3.37/src/dsr/model/dsr-fs-header.cc	2022-11-01 17:37:24.479395200 -0700
+++ ns-3.38/src/dsr/model/dsr-fs-header.cc	2023-03-16 20:54:23.600868500 -0700
@@ -273,7 +273,7 @@
 }
 
 uint32_t
-DsrOptionField::GetDsrOptionsOffset()
+DsrOptionField::GetDsrOptionsOffset() const
 {
     return m_optionsOffset;
 }
diff -Naur -x '*.dia' -x '*.pcap' -x '*.png' ns-3.37/src/dsr/model/dsr-fs-header.h ns-3.38/src/dsr/model/dsr-fs-header.h
--- ns-3.37/src/dsr/model/dsr-fs-header.h	2022-11-01 17:37:24.479395200 -0700
+++ ns-3.38/src/dsr/model/dsr-fs-header.h	2023-03-16 20:54:23.604868400 -0700
@@ -247,7 +247,7 @@
      * the extension header.
      * \return the offset from the start of the extension header
      */
-    uint32_t GetDsrOptionsOffset();
+    uint32_t GetDsrOptionsOffset() const;
     /**
      * \brief Get the buffer.
      * \return buffer
diff -Naur -x '*.dia' -x '*.pcap' -x '*.png' ns-3.37/src/dsr/model/dsr-option-header.cc ns-3.38/src/dsr/model/dsr-option-header.cc
--- ns-3.37/src/dsr/model/dsr-option-header.cc	2022-11-01 17:37:24.483395000 -0700
+++ ns-3.38/src/dsr/model/dsr-option-header.cc	2023-03-16 20:54:23.604868400 -0700
@@ -1085,15 +1085,15 @@
 }
 
 void
-DsrOptionRerrUnsupportHeader::SetUnsupported(uint16_t unsupport)
+DsrOptionRerrUnsupportHeader::SetUnsupported(uint16_t unsupported)
 {
-    m_unsupport = unsupport;
+    m_unsupported = unsupported;
 }
 
 uint16_t
 DsrOptionRerrUnsupportHeader::GetUnsupported() const
 {
-    return m_unsupport;
+    return m_unsupported;
 }
 
 void
@@ -1102,7 +1102,7 @@
     os << "( type = " << (uint32_t)GetType() << " length = " << (uint32_t)GetLength()
        << " errorType = " << (uint32_t)m_errorType << " salvage = " << (uint32_t)m_salvage
        << " error source = " << m_errorSrcAddress << " error dst = " << m_errorDstAddress
-       << " unsupported option = " << m_unsupport << " )";
+       << " unsupported option = " << m_unsupported << " )";
 }
 
 uint32_t
@@ -1122,7 +1122,7 @@
     i.WriteU8(m_salvage);
     WriteTo(i, m_errorSrcAddress);
     WriteTo(i, m_errorDstAddress);
-    i.WriteU16(m_unsupport);
+    i.WriteU16(m_unsupported);
 }
 
 uint32_t
@@ -1136,7 +1136,7 @@
     m_salvage = i.ReadU8();
     ReadFrom(i, m_errorSrcAddress);
     ReadFrom(i, m_errorDstAddress);
-    m_unsupport = i.ReadU16();
+    m_unsupported = i.ReadU16();
 
     return GetSerializedSize();
 }
diff -Naur -x '*.dia' -x '*.pcap' -x '*.png' ns-3.37/src/dsr/model/dsr-option-header.h ns-3.38/src/dsr/model/dsr-option-header.h
--- ns-3.37/src/dsr/model/dsr-option-header.h	2022-11-01 17:37:24.483395000 -0700
+++ ns-3.38/src/dsr/model/dsr-option-header.h	2023-03-16 20:54:23.604868400 -0700
@@ -1136,7 +1136,7 @@
     /**
      * \brief The unsupported option
      */
-    uint16_t m_unsupport;
+    uint16_t m_unsupported;
 };
 
 /**
diff -Naur -x '*.dia' -x '*.pcap' -x '*.png' ns-3.37/src/dsr/model/dsr-options.cc ns-3.38/src/dsr/model/dsr-options.cc
--- ns-3.37/src/dsr/model/dsr-options.cc	2022-11-01 17:37:24.483395000 -0700
+++ ns-3.38/src/dsr/model/dsr-options.cc	2023-03-16 20:54:23.604868400 -0700
@@ -266,7 +266,7 @@
     /*
      * Check elements in a route vector
      */
-    if (!vec.size())
+    if (vec.empty())
     {
         NS_LOG_DEBUG("The vector is empty");
     }
@@ -1112,7 +1112,7 @@
     {
         RemoveDuplicates(nodeList); // This is for the route reply from intermediate node since we
                                     // didn't remove duplicate there
-        if (nodeList.size() == 0)
+        if (nodeList.empty())
         {
             NS_LOG_DEBUG("The route we have contains 0 entries");
             return 0;
